FROM golang:1.19-bullseye AS base

RUN apt-get update
RUN apt-get install -y libssl-dev cmake build-essential gperf libz-dev make git php

FROM base AS tdlib

ARG TD_COMMIT
ARG MAKEOPTS
RUN git clone https://github.com/tdlib/td /src/
RUN git -C /src/ checkout "${TD_COMMIT}"
RUN mkdir build
WORKDIR /build/
RUN cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/compiled/ /src/
RUN cmake --build . --target prepare_cross_compiling ${MAKEOPTS}
WORKDIR /src/
RUN php SplitSource.php
WORKDIR /build/
RUN cmake --build . ${MAKEOPTS}
RUN make install

FROM scratch AS binaries
COPY --from=tdlib /compiled/ /
